diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -22122,7 +25905,7 @@ u_int16_t MP_ReadPhyUshort(struct re_softc *sc,u_int8_t RegAddr)
                 RegData = (u_int16_t)(TmpUlong & 0x0000ffff);
 
                 if (sc->re_type == MACFG_65 || sc->re_type == MACFG_66)
-                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc,0xD0) | 0x00020000);
+                        CSR_WRITE_4(sc, 0xD0, CSR_READ_4(sc, 0xD0) | 0x00020000);
         }
 
         return RegData;
@@ -22167,30 +25950,147 @@ u_int16_t MP_ReadEPhyUshort(struct re_softc *sc, u_int8_t RegAddr)
         return RegData;
 }
 
-u_int8_t MP_ReadEfuse(struct re_softc *sc, u_int16_t RegAddr)
+static u_int8_t re_calc_efuse_dummy_bit(u_int16_t reg)
 {
-        u_int8_t		RegData;
-        u_int32_t		TmpUlong;
-        u_int32_t		Timeout=0;
+        int s,a,b;
+        u_int8_t dummyBitPos = 0;
 
-        RegAddr &= 0x3FF;
-        TmpUlong = ((u_int32_t)RegAddr << 8);
-        CSR_WRITE_4(sc, 0xDC, TmpUlong);
 
-        /* Wait for writing to Phy ok */
-        for (Timeout=0; Timeout<5; Timeout++) {
-                DELAY(1000);
-                TmpUlong = CSR_READ_4(sc, 0xDC);
-                if ((TmpUlong&PHYAR_Flag)!=0)
-                        break;
+        s=reg% 32;
+        a=s % 16;
+        b=s/16;
+
+        if (s/16) {
+                dummyBitPos = (u_int8_t)(16-a);
+        } else {
+                dummyBitPos = (u_int8_t)a;
         }
 
-        RegData = (u_int8_t)(TmpUlong & 0x000000ff);
+        return dummyBitPos;
+}
 
-        return RegData;
+static u_int32_t re_decode_efuse_cmd(struct re_softc *sc, u_int32_t DwCmd)
+{
+        u_int16_t reg = (u_int16_t)((DwCmd & 0x00FE0000) >> 17);
+        u_int32_t DummyPos = re_calc_efuse_dummy_bit(reg);
+        u_int32_t DeCodeDwCmd = DwCmd;
+        u_int32_t Dw17BitData;
+
+
+        if (sc->re_efuse_ver < 3) {
+                DeCodeDwCmd = (DwCmd>>(DummyPos+1))<<DummyPos;
+                if (DummyPos > 0) {
+                        DeCodeDwCmd |= ((DwCmd<<(32-DummyPos))>>(32-DummyPos));
+                }
+        } else {
+                reg = (u_int16_t)((DwCmd & 0x007F0000) >> 16);
+                DummyPos = re_calc_efuse_dummy_bit(reg);
+                Dw17BitData = ((DwCmd & BIT_23) >> 23);
+                Dw17BitData <<= 16;
+                Dw17BitData |= (DwCmd & 0x0000FFFF);
+                DeCodeDwCmd = (Dw17BitData>>(DummyPos+1))<<DummyPos;
+                if (DummyPos > 0) {
+                        DeCodeDwCmd |= ((Dw17BitData<<(32-DummyPos))>>(32-DummyPos));
+                }
+        }
+
+        return DeCodeDwCmd;
+}
+
+#define EFUSE_WRITE 0x80000000
+#define EFUSE_WRITE_OK  0x00000000
+#define EFUSE_READ  0x00000000
+#define EFUSE_READ_OK  0x80000000
+#define EFUSE_Reg_Mask 0x03FF
+#define EFUSE_Reg_Shift 8
+#define EFUSE_Check_Cnt 300
+#define EFUSE_READ_FAIL 0xFF
+#define EFUSE_Data_Mask 0x000000FF
+
+u_int8_t MP_ReadEfuse(struct re_softc *sc, u_int16_t reg)
+{
+        u_int8_t efuse_data = 0;
+        u_int32_t temp;
+        u_int32_t cnt;
+
+        if (sc->re_efuse_ver == EFUSE_NOT_SUPPORT)
+                return EFUSE_READ_FAIL;
+
+        if (sc->re_efuse_ver == EFUSE_SUPPORT_V1) {
+                temp = EFUSE_READ | ((reg & EFUSE_Reg_Mask) << EFUSE_Reg_Shift);
+                CSR_WRITE_4(sc, RE_EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        DELAY(100);
+                        temp = CSR_READ_4(sc, RE_EFUSEAR);
+                        cnt++;
+                } while (!(temp & EFUSE_READ_OK) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt)
+                        efuse_data = EFUSE_READ_FAIL;
+                else
+                        efuse_data = (u_int8_t)(CSR_READ_4(sc, RE_EFUSEAR) & EFUSE_Data_Mask);
+        } else  if (sc->re_efuse_ver == EFUSE_SUPPORT_V2) {
+                temp = (reg/2) & 0x03ff;
+                temp <<= 17;
+                temp |= EFUSE_READ;
+                CSR_WRITE_4(sc, RE_EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        DELAY(100);
+                        temp = CSR_READ_4(sc, RE_EFUSEAR);
+                        cnt++;
+                } while (!(temp & EFUSE_READ_OK) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt) {
+                        efuse_data = EFUSE_READ_FAIL;
+                } else {
+                        temp = CSR_READ_4(sc, RE_EFUSEAR);
+                        temp = re_decode_efuse_cmd(sc, temp);
+
+                        if (reg%2) {
+                                temp >>= 8;
+                                efuse_data = (u_int8_t)temp;
+                        } else {
+                                efuse_data = (u_int8_t)temp;
+                        }
+                }
+        } else  if (sc->re_efuse_ver == EFUSE_SUPPORT_V3) {
+                temp = (reg/2) & 0x03ff;
+                temp <<= 16;
+                temp |= EFUSE_READ;
+                CSR_WRITE_4(sc, RE_EFUSEAR, temp);
+
+                cnt = 0;
+                do {
+                        DELAY(100);
+                        temp = CSR_READ_4(sc, RE_EFUSEAR);
+                        cnt++;
+                } while (!(temp & EFUSE_READ_OK) && (cnt < EFUSE_Check_Cnt));
+
+                if (cnt == EFUSE_Check_Cnt) {
+                        efuse_data = EFUSE_READ_FAIL;
+                } else {
+                        temp = CSR_READ_4(sc, RE_EFUSEAR);
+                        temp = re_decode_efuse_cmd(sc, temp);
+
+                        if (reg%2) {
+                                temp >>= 8;
+                                efuse_data = (u_int8_t)temp;
+                        } else {
+                                efuse_data = (u_int8_t)temp;
+                        }
+                }
+        }
+
+        DELAY(20);
+
+        return efuse_data;
 }
 
-static void MP_WriteOtherFunPciEConfigSpace(
+void MP_WriteOtherFunPciEConfigSpace(
         struct re_softc *sc,
         u_int8_t MultiFunSelBit,
         u_int16_t ByteEnAndAddr,
@@ -22221,7 +26121,7 @@ static void MP_WriteOtherFunPciEConfigSpace(
         DELAY(50);
 }
 
-static u_int32_t MP_ReadOtherFunPciEConfigSpace(
+u_int32_t MP_ReadOtherFunPciEConfigSpace(
         struct re_softc *sc,
         u_int8_t MultiFunSelBit,
         u_int16_t ByteEnAndAddr)
@@ -22499,16 +26399,21 @@ static u_int32_t real_ocp_read(struct re_softc *sc, u_int16_t addr, u_int8_t len
         return value2;
 }
 
+static u_int32_t OCP_read_with_oob_base_address(struct re_softc *sc, u_int16_t addr, u_int8_t len, const u_int32_t base_address)
+{
+        return re_eri_read_with_oob_base_address(sc, addr, len, ERIAR_OOB, base_address);
+}
+
 static u_int32_t OCP_read(struct re_softc *sc, u_int16_t addr, u_int8_t len)
 {
         u_int32_t value = 0;
 
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc))
                 value = re_eri_read(sc, addr, len, ERIAR_OOB);
-        } else {
+        else if (HW_DASH_SUPPORT_TYPE_3(sc))
+                value = OCP_read_with_oob_base_address(sc, addr, len, RTL8168FP_OOBMAC_BASE);
+        else
                 value = real_ocp_read(sc, addr, len);
-        }
 
         return value;
 }
@@ -22558,14 +26463,19 @@ static int real_ocp_write(struct re_softc *sc, u_int16_t addr, u_int8_t len, u_i
         return 0;
 }
 
+static int OCP_write_with_oob_base_address(struct re_softc *sc, u_int16_t addr, u_int8_t len, u_int32_t value, const u_int32_t base_address)
+{
+        return re_eri_write_with_oob_base_address(sc, addr, len, value, ERIAR_OOB, base_address);
+}
+
 static void OCP_write(struct re_softc *sc, u_int16_t addr, u_int8_t len, u_int32_t value)
 {
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc))
                 re_eri_write(sc, addr, len, value, ERIAR_OOB);
-        } else {
+        else if (HW_DASH_SUPPORT_TYPE_3(sc))
+                OCP_write_with_oob_base_address(sc, addr, len, value, RTL8168FP_OOBMAC_BASE);
+        else
                 real_ocp_write(sc, addr, len, value);
-        }
 }
 
 static void OOB_mutex_lock(struct re_softc *sc)
@@ -22592,6 +26502,8 @@ static void OOB_mutex_lock(struct re_softc *sc)
         case MACFG_61:
         case MACFG_62:
         case MACFG_67:
+        case MACFG_70:
+        case MACFG_71:
         default:
                 ocp_reg_mutex_oob = 0x110;
                 ocp_reg_mutex_ib = 0x114;
@@ -22650,6 +26562,8 @@ static void OOB_mutex_unlock(struct re_softc *sc)
         case MACFG_61:
         case MACFG_62:
         case MACFG_67:
+        case MACFG_70:
+        case MACFG_71:
         default:
                 ocp_reg_mutex_oob = 0x110;
                 ocp_reg_mutex_ib = 0x114;
@@ -22663,24 +26577,37 @@ static void OOB_mutex_unlock(struct re_softc *sc)
 
 static int re_check_dash(struct re_softc *sc)
 {
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
-                if (OCP_read(sc, 0x128, 1) & BIT_0)
-                        return 1;
-                else
-                        return 0;
-        } else {
-                u_int32_t reg;
+        switch(sc->re_type) {
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+        case MACFG_63:
+        case MACFG_64:
+        case MACFG_65:
+        case MACFG_66:
+        case MACFG_70:
+        case MACFG_71:
+                if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
+                        if (OCP_read(sc, 0x128, 1) & BIT_0)
+                                return 1;
+                        else
+                                return 0;
+                } else {
+                        u_int32_t reg;
 
-                if (sc->re_type == MACFG_66)
-                        reg = 0xb8;
-                else
-                        reg = 0x10;
+                        if (sc->re_type == MACFG_66)
+                                reg = 0xb8;
+                        else
+                                reg = 0x10;
 
-                if (OCP_read(sc, reg, 2) & 0x00008000)
-                        return 1;
-                else
-                        return 0;
+                        if (OCP_read(sc, reg, 2) & 0x00008000)
+                                return 1;
+                        else
+                                return 0;
+                }
+                break;
+        default:
+                return 0;
         }
 }
 
@@ -22702,11 +26629,10 @@ static void OOB_notify(struct re_softc *sc, u_int8_t cmd)
 
 void re_driver_start(struct re_softc *sc)
 {
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
                 u_int32_t tmp_value;
 
-                if (!re_check_dash(sc))
+                if (!sc->re_dash)
                         return;
 
                 OCP_write(sc, 0x180, 1, OOB_CMD_DRIVER_START);
@@ -22738,11 +26664,10 @@ void re_driver_start(struct re_softc *sc)
 
 void re_driver_stop(struct re_softc *sc)
 {
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
                 u_int32_t tmp_value;
 
-                if (!re_check_dash(sc))
+                if (!sc->re_dash)
                         return;
 
                 Dash2DisableTxRx(sc);
@@ -23071,4 +26996,15 @@ rtl_phy_power_down(struct re_softc *sc)
 	re_phy_power_down(sc->dev);
 }
 
+void
+rtl_cmac_unmap(struct re_softc *sc)
+{
+
+	if (HW_DASH_SUPPORT_TYPE_3(sc) && sc->re_dash &&
+	    sc->re_mapped_cmac_handle != 0) {
+		bus_space_unmap(sc->re_cmac_tag, sc->re_mapped_cmac_handle,
+		    RE_REGS_SIZE);
+	}
+}
+
 #endif	/* __DragonFly__ */
diff --git a/sys/dev/netif/re/re.h b/sys/dev/netif/re/re.h
index db4b0f3a91..c845d73f46 100644
--- a/sys/dev/netif/re/re.h
+++ b/sys/dev/netif/re/re.h
@@ -117,6 +117,7 @@
 #define RE_CFG4		0x0055		/* config register #4 */
 #define RE_CFG5		0x0056		/* config register #5 */
 /* 0053-0057 reserved */
+#define RE_TDFNR	0x0057		/* Tx descriptor fetch number */
 #define RE_MEDIASTAT	0x0058		/* media status register (8139) */
 /* 0059-005A reserved */
 #define RE_MII		0x005A		/* 8129 chip only */
@@ -144,12 +145,13 @@
 #define RE_TwiCmdReg	0x00D2
 #define RE_MCU_CMD	0x00D3
 #define RE_RxMaxSize	0x00DA
+#define RE_EFUSEAR	0x00DC
 #define RE_CPlusCmd	0x00E0
 #define	RE_MTPS		0x00EC
-#define	RE_IBCR0     	0x00F8
-#define	RE_IBCR2     	0x00F9
-#define	RE_IBIMR0    	0x00FA
-#define	RE_IBISR0   	0x00FB
+#define	RE_CMAC_IBCR0     	0x00F8
+#define	RE_CMAC_IBCR2     	0x00F9
+#define	RE_CMAC_IBIMR0    	0x00FA
+#define	RE_CMAC_IBISR0   	0x00FB
 
 /* ERI access */
 #define	ERIAR_Flag   0x80000000
@@ -781,6 +783,13 @@ struct re_mii_frame {
 
 #define RL_RxChkSum (1<<5)
 
+enum  {
+        EFUSE_NOT_SUPPORT = 0,
+        EFUSE_SUPPORT_V1,
+        EFUSE_SUPPORT_V2,
+        EFUSE_SUPPORT_V3,
+};
+
 enum {
         MACFG_3 = 3,
         MACFG_4,
@@ -839,6 +848,8 @@ enum {
         MACFG_67,
         MACFG_68,
         MACFG_69,
+        MACFG_70,
+        MACFG_71,
 
         MACFG_FF = 0xFF
 };
@@ -902,6 +913,13 @@ struct re_softc {
 
         u_int8_t RequireAdjustUpsTxLinkPulseTiming;
         u_int16_t SwrCnt1msIni;
+
+        u_int8_t RequiredSecLanDonglePatch;
+
+        u_int8_t  re_efuse_ver;
+
+        u_int16_t re_sw_ram_code_ver;
+        u_int16_t re_hw_ram_code_ver;
 #if OS_VER>=VERSION(7,0)
         struct task		re_inttask;
 #endif
@@ -916,6 +934,14 @@ struct re_softc {
         u_int8_t	prohibit_access_reg;
 
         u_int8_t	re_hw_supp_now_is_oob_ver;
+
+        u_int8_t HwSuppDashVer;
+        u_int8_t	re_dash;
+        bus_space_handle_t	re_mapped_cmac_handle;			/* bus space tag */
+        bus_space_tag_t		re_mapped_cmac_tag;			/* bus space tag */
+        bus_space_handle_t	re_cmac_handle;		/* bus space handle */
+        bus_space_tag_t		re_cmac_tag;			/* bus space tag */
+        u_int8_t HwPkgDet;
 };
 #endif	/* !__DragonFly__ */
 
@@ -975,6 +1001,14 @@ enum bits {
 #define CSR_READ_4(sc, reg)	((sc->prohibit_access_reg)?0xFFFFFFFF:bus_space_read_4(sc->re_btag, sc->re_bhandle, reg))
 #define CSR_READ_2(sc, reg)	((sc->prohibit_access_reg)?0xFFFF:bus_space_read_2(sc->re_btag, sc->re_bhandle, reg))
 #define CSR_READ_1(sc, reg)	((sc->prohibit_access_reg)?0xFF:bus_space_read_1(sc->re_btag, sc->re_bhandle, reg))
+
+/* cmac write/read MMIO register */
+#define RE_CMAC_WRITE_1(sc, reg, val) ((sc->prohibit_access_reg)?:bus_space_write_1(sc->re_cmac_tag, sc->re_cmac_handle, reg, val))
+#define RE_CMAC_WRITE_2(sc, reg, val) ((sc->prohibit_access_reg)?:bus_space_write_2(sc->re_cmac_tag, sc->re_cmac_handle, reg, val))
+#define RE_CMAC_WRITE_4(sc, reg, val) ((sc->prohibit_access_reg)?:bus_space_write_4(sc->re_cmac_tag, sc->re_cmac_handle, reg, val))
+#define RE_CMAC_READ_1(sc, reg) ((sc->prohibit_access_reg)?0xFF:bus_space_read_1(sc->re_cmac_tag, sc->re_cmac_handle, reg))
+#define RE_CMAC_READ_2(sc, reg) ((sc->prohibit_access_reg)?0xFFFF:bus_space_read_2(sc->re_cmac_tag, sc->re_cmac_handle, reg))
+#define RE_CMAC_READ_4(sc, reg) (sc->prohibit_access_reg)?0xFFFFFFFF:bus_space_read_4(sc->re_cmac_tag, sc->re_cmac_handle, reg))
 #endif	/* !__DragonFly__ */
 
 #define RE_TIMEOUT		1000
@@ -1074,6 +1108,18 @@ enum bits {
 #define RE_WOL_LINK_SPEED_10M_FIRST ( 0 )
 #define RE_WOL_LINK_SPEED_100M_FIRST ( 1 )
 
+//Ram Code Version
+#define NIC_RAMCODE_VERSION_8168E (0x0057)
+#define NIC_RAMCODE_VERSION_8168EVL (0x0055)
+#define NIC_RAMCODE_VERSION_8168F (0x0044)
+#define NIC_RAMCODE_VERSION_8411 (0x0044)
+#define NIC_RAMCODE_VERSION_8168G (0x0042)
+#define NIC_RAMCODE_VERSION_8168GU (0x0001)
+#define NIC_RAMCODE_VERSION_8168EP (0x0015)
+#define NIC_RAMCODE_VERSION_8411B (0x0012)
+#define NIC_RAMCODE_VERSION_8168H (0x0018)
+#define NIC_RAMCODE_VERSION_8168FP (0x0003)
+
 #ifdef __alpha__
 #undef vtophys
 #define vtophys(va)     alpha_XXX_dmamap((vm_offset_t)va)
@@ -1093,6 +1139,14 @@ enum bits {
 /* the minimum value is 1 */
 #define	INTR_MAX_LOOP	1
 
+#define RE_REGS_SIZE     (256)
+
+#define RTL8168FP_OOBMAC_BASE 0xBAF70000
+#define HW_DASH_SUPPORT_DASH(_M)        ((_M)->HwSuppDashVer > 0 )
+#define HW_DASH_SUPPORT_TYPE_1(_M)        ((_M)->HwSuppDashVer == 1 )
+#define HW_DASH_SUPPORT_TYPE_2(_M)        ((_M)->HwSuppDashVer == 2 )
+#define HW_DASH_SUPPORT_TYPE_3(_M)        ((_M)->HwSuppDashVer == 3 )
+
 /*#define RE_DBG*/
 
 #ifdef RE_DBG
diff --git a/sys/dev/netif/re/re_dragonfly.h b/sys/dev/netif/re/re_dragonfly.h
index 417a3897f1..69152eaada 100644
--- a/sys/dev/netif/re/re_dragonfly.h
+++ b/sys/dev/netif/re/re_dragonfly.h
@@ -39,6 +39,20 @@
 	((RE_INTRS & ~(RE_ISR_TX_OK | RE_ISR_RX_OK | RE_ISR_RX_OVERRUN |\
 	  RE_ISR_PKT_UNDERRUN | RE_ISR_TDU)) | RE_ISR_PCS_TIMEOUT)
 
+/* cmac write/read MMIO register */
+#define RE_CMAC_WRITE_1(sc, reg, val)	\
+	bus_space_write_1(sc->re_cmac_tag, sc->re_cmac_handle, reg, val)
+#define RE_CMAC_WRITE_2(sc, reg, val)	\
+	bus_space_write_2(sc->re_cmac_tag, sc->re_cmac_handle, reg, val)
+#define RE_CMAC_WRITE_4(sc, reg, val)	\
+	bus_space_write_4(sc->re_cmac_tag, sc->re_cmac_handle, reg, val)
+#define RE_CMAC_READ_1(sc, reg)		\
+	bus_space_read_1(sc->re_cmac_tag, sc->re_cmac_handle, reg)
+#define RE_CMAC_READ_2(sc, reg)		\
+	bus_space_read_2(sc->re_cmac_tag, sc->re_cmac_handle, reg)
+#define RE_CMAC_READ_4(sc, reg)		\
+	bus_space_read_4(sc->re_cmac_tag, sc->re_cmac_handle, reg)
+
 int		rtl_check_mac_version(struct re_softc *);
 void		rtl_init_software_variable(struct re_softc *);
 void		rtl_exit_oob(struct re_softc *);
@@ -58,5 +72,6 @@ void		rtl_hw_start(struct re_softc *);
 void		rtl_set_rx_packet_filter(struct re_softc *);
 void		rtl_hw_d3_para(struct re_softc *);
 void		rtl_phy_power_down(struct re_softc *);
+void		rtl_cmac_unmap(struct re_softc *);
 
 #endif	/* !_RE_DRAGONFLY_H_ */
diff --git a/sys/platform/pc64/x86_64/busdma_machdep.c b/sys/platform/pc64/x86_64/busdma_machdep.c
index 884b3ffbb2..62e1163589 100644
--- a/sys/platform/pc64/x86_64/busdma_machdep.c
+++ b/sys/platform/pc64/x86_64/busdma_machdep.c
@@ -48,6 +48,7 @@
 #include <vm/vm_map.h>
 
 #include <machine/md_var.h>
+#include <machine/pmap.h>
 
 #include <bus/cam/cam.h>
 #include <bus/cam/cam_ccb.h>
@@ -1478,3 +1479,22 @@ busdma_swi(void)
 	}
 	spin_unlock(&bounce_map_list_spin);
 }
+
+int
+bus_space_map(bus_space_tag_t t __unused, bus_addr_t addr, bus_size_t size,
+    int flags __unused, bus_space_handle_t *bshp)
+{
+
+	if (t == X86_64_BUS_SPACE_MEM)
+		*bshp = (uintptr_t)pmap_mapdev(addr, size);
+	else
+		*bshp = addr;
+	return (0);
+}
+
+void
+bus_space_unmap(bus_space_tag_t t, bus_space_handle_t bsh, bus_size_t size)
+{
+	if (t == X86_64_BUS_SPACE_MEM)
+		pmap_unmapdev(bsh, size);
+}
